cls;

$dayNames = @(@{est="E"; eng="Monday"}, @{est="T"; eng="Tuesday"},
            @{est="K"; eng="Wednesday"}, @{est="N"; eng="Thursday"},
            @{est="R"; eng="Friday"}, @{est="L"; eng="Saturday"},
            @{est="P"; eng="Sunday"}); #vähem-kui-geniaalne viis päevade eestindamiseks - muukeeleses windowsis ilmselt ei tööta.

$weeks = @();
$days = @();

$month = (Get-Date).month;
$dayOne = (Get-Date -day 1);

$currentWeek = @{days = 0;value = -1};
$dayIndex = 0;
$tempDate = (Get-Date);

for($i = 0; $i -lt $dayNames.length; $i++) {
    if($dayOne.dayofweek -eq $dayNames[$i].eng) {
        $dayIndex = $i;
        break;
    }
}
   
for($i = 0; $i -lt 32; $i++) {
    $tempDate = $dayOne.AddDays($i);

    if($tempDate.month -ne $month) { #sama kuu sees?
        break;
    }
        
    if($currentWeek.value -ne (Get-Date -date $tempDate -uformat %W)) { #kaevame välja nädala etteantud kuupäevast
        $currentWeek = @{days = @(); value = [int](Get-Date -date $tempDate -uformat %W)};
        $weeks += ($currentWeek);
    }
    
    $day = @{week=$currentWeek; dayName=$dayNames[$dayIndex%$dayNames.length]; value=[int]$tempDate.day}; #tahaks, et value oleks int tüüpi
    
    $days += $day; #push() ekvivalent
    $currentWeek.days += $day;
    
    $dayIndex++;
}

$spaces = "  ";

for($i = 0; $i -lt $weeks.length; $i++) {#kui on kõik kahekohalised nädalad, on vaja ette rohkem tühikuid    
    if($weeks[$i].value -gt 9) {
        $spaces = "   ";
        break;
    }
}


Write-Host $spaces -noNewLine;

$tempDate = (Get-Date); #seda initsialiseeringut kasutab ka nädalate-päevade joonistamine! siia addDays'i tehes saab kontrollida töötavust

for($i = 0; $i -lt 7; $i++) {
    if($tempDate.dayOfWeek -eq $dayNames[$i].eng) {
        Write-Host $dayNames[$i].est -foregroundcolor "red" -noNewLine;
    }
    else {
        Write-Host $dayNames[$i].est -noNewLine;
    }
    
    Write-Host "  " -noNewLine;
}

Write-Host;

for($i = 0; $i -lt $weeks.length; $i++) {
    if($weeks[$i].value -gt 9) { #nädala number
        $spaces = " ";
    }
    else {
        $spaces = "  ";
    }
    
    $hasToday = 0;
    
    for($j = 0; $j -lt $weeks[$i].days.length; $j++) {
        if($weeks[$i].days[$j].value -eq $tempDate.day) {
            $hasToday = 1;
            break;
        }
    }
    
    if($hasToday -eq 1) { #kui selles nädalas sisaldub tänane päev, tuleb see punaselt joonistada; muidu valgelt
        Write-Host $weeks[$i].value -foregroundcolor "red" -noNewLine;
    }
    else {
        Write-Host $weeks[$i].value -noNewLine;
    }
    
    Write-Host $spaces -noNewLine;
    
    $k = 0;
    
    for($j = 0; $j -lt $dayNames.length; $j++) {
        if($weeks[$i].days[$k].dayName -eq $dayNames[$j]) { #kas antud päev langeb selle nädalapäeva alla, mille juures praegu oleme? kui ei, tuleb tühikud sinna jätta
            if($tempDate.day -eq $weeks[$i].days[$k].value) {
                Write-Host  $weeks[$i].days[$k].value -foregroundcolor "red" -noNewLine;
            }
            else {
                Write-Host  $weeks[$i].days[$k].value -noNewLine;
            }
            
            if($weeks[$i].days[$k].value -gt 9) {
                $spaces = " ";
            }
            else {
                $spaces = "  ";
            }
            
            Write-Host $spaces -noNewLine;
            $k++
        }
        else {
            Write-Host "   " -noNewLine;
        }
    }
    
    Write-Host;#iga nädala vahel on üks reavahetus
}

Write-Host;#konsoolirida kaugemale nihutada